diff --git a/diffoscope/comparators/zip.py b/diffoscope/comparators/zip.py
index 2a27042a..4bfb1527 100644
--- a/diffoscope/comparators/zip.py
+++ b/diffoscope/comparators/zip.py
@@ -182,7 +182,12 @@ class ZipDirectory(Directory, ArchiveMember):
 
 class ZipContainer(Archive):
     def open_archive(self):
-        return zipfile.ZipFile(self.source.path, "r")
+        zf = zipfile.ZipFile(self.source.path, "r")
+        self.name_to_info = {}
+        for info in zf.infolist():
+            if info.filename not in self.name_to_info:
+                self.name_to_info[info.filename] = info
+        return zf
 
     def close_archive(self):
         self.archive.close()
@@ -199,7 +204,8 @@ class ZipContainer(Archive):
         ).encode(sys.getfilesystemencoding(), errors="replace")
 
         try:
-            with self.archive.open(member_name) as source, open(
+            info = self.name_to_info[member_name]
+            with self.archive.open(info) as source, open(
                 targetpath, "wb"
             ) as target:
                 shutil.copyfileobj(source, target)
